
PUB  Start (params)
  result := cognew (@entry, params)
DAT
              org       0
entry         mov       parm, par
:reload       rdlong    value, parm
	      add	parm, #4
	      rdlong	dp_place, parm
	      add	parm, #4
	      rdlong	flashdig, parm
	      mov	tmp, #9
	      sub	tmp, flashdig
	      mov	flashdig, tmp
	      sub	parm, #8
              call      #display_int
              jmp       #:reload


display_int   call      #init_7seg
              mov       leadz, #1
              cmps      value, #0  wc
        if_c  neg       value, value
        if_c  mov       patt, minus
        if_c  call      #do7seg
              call      #top_digit
              call      #do7seg
              mov       n, #8
:scan_digs    call      #do_digit
              cmp       n, dp_place  wz
        if_nz cmp       n, dp2_place  wz
        if_z  or        patt, #1
        if_z  mov       leadz, #0
              call      #do7seg
              djnz      n, #:scan_digs
              mov       leadz, #0
              call      #do_digit
              call      #do7seg
display_int_ret  ret

top_digit     mov       dig, #0
:loop         cmpsub    value, billion  wc
        if_c  add       dig, #1
        if_c  jmp       #:loop
              cmp       dig, #0  wz
        if_nz mov       leadz, #0
              cmp       leadz, #0  wz
              mov       patt, #0
        if_z  call      #lookup_digit
top_digit_ret ret

lookup_digit  cmp       dig, #8  wc
        if_c  jmp       #:else
              cmp       dig, #$C  wc
        if_c  mov       patt, lut89ab
        if_nc mov       patt, lutcdef
              jmp       #:rdy
:else         cmp       dig, #4  wc
        if_c  mov       patt, lut0123
        if_nc mov       patt, lut4567
:rdy          and       dig, #3
              shl       dig, #3
              shr       patt, dig
              and       patt, #$FF
lookup_digit_ret ret


do_digit      mov       dig, #0
:loop         cmpsub    value, power10  wc
        if_c  add       dig, #1
        if_c  jmp       #:loop
              shl       value, #1
              mov       tmp, value
              shl       tmp, #2
              add       value, tmp
              cmp       dig, #0  wz
        if_nz mov       leadz, #0
              cmp       leadz, #0  wz
              mov       patt, #0
        if_z  call      #lookup_digit
do_digit_ret  ret




        
init_7seg     mov       i, #0
              mov       cathode, #1
              shl       cathode, segcount
              mov       mask7seg, cathode
              sub       mask7seg, #1
init_7seg_ret ret

do7seg        cmp       i, segcount  wc
        if_nc jmp       #do7seg_ret
              shr       cathode, #1
              
              mov       tmp, patt
              shl       tmp, segcount
              or        patt, tmp
              mov       tmp, i
              andn      tmp, #1
              shr       patt, tmp
              and       patt, mask7seg



	      cmp	i, flashdig  wz
	if_nz jmp	#:noblinking
	      test	flashclk, cnt  wz
        if_z  xor	patt, mask7seg

:noblinking   mov       direct, patt
              or        direct, cathode
              mov       output, mask7seg
              andn      output, cathode

              mov       tmp, #32
              sub       tmp, segcount
              test      reverse, reverse  wz
        if_nz rev       direct, tmp
        if_nz rev       output, tmp
              shl       direct, base7seg
              mov	dira, direct
              shl       output, base7seg
              mov       outa, output
          
              mov       time, cnt
              add       time, segdelay
:tloop        cmp       patt, #0  wz
        if_z  jmp       #:done_tloop
              test      patt, #1  wz
        if_nz waitcnt   time, segdelay
              shr       patt, #1
              jmp       #:tloop
:done_tloop
              mov       dira, #0
              add       i, #1
              
do7seg_ret    ret


segcount      long      10
segdelay      long      1_000
minus         long      $02
power10       long      100_000_000
billion       long      1_000_000_000
flashclk      long	$75 << 19

base7seg      long      0
dp_place      long      3
dp2_place     long      20
reverse       long      1

lut0123       long      $F2DA60FC
lut4567       long      $E0BEB666
lut89ab       long      $3EEEF6FE
lutcdef       long      $8E9E7A9C
mask7seg      res       1
time          res       1
parm          res       1

i             res       1
n             res       1
value         res       1
tmp           res       1
cathode       res       1
patt          res       1
direct        res       1
output        res       1
dig           res       1
leadz         res       1
flashdig      res	1

	      fit	$1F0
